-- installer for collect aseet script
SETUP_PATH = ((getdir #userScripts) + "\\Collect_asset\\")
tempdirCA = getdir(#temp)+"\\CA_install_temp\\"
usericonspath = getdir(#userIcons)
err = 0

fn CAdeltmp =
(
 	HiddenDOSCommand ("rmdir /S /Q \""+tempdirCA+"\"")
	callbacks.removeScripts id:#CAdeltmp
)
callbacks.addScript #preSystemShutdown "CAdeltmp()" id:#CAdeltmp --delete temp folder on 3ds max exit

rollout installed_wnd "Script Installed" width:592 height:712
(
	button 'btn_ok' "Ok" pos:[225,664] width:112 height:32 align:#left
	bitmap 'bmp5' "Bitmap" pos:[8,64] width:572 height:590 fileName:(tempdirCA+"Collect_Asset_toolbar.png")
	label 'lbl1' "Script Collect Asset Installed!" pos:[211,10] width:176 height:24 align:#left
	label 'lbl2' "No Errors" pos:[8,40] width:232 height:24 align:#left

	on installed_wnd open do
	(
		if err > 0 do
			lbl2.text = "Errors - " + err as string
	)
	on btn_ok pressed do
	(
		DestroyDialog installed_wnd
	)
)

rollout Collect_Asset_install "Collect Asset installer" width:202 height:224
(
	bitmap 'bmp1' "Bitmap" pos:[-2,1] width:205 height:58 fileName:(tempdirCA+"logo.gif") align:#left
	button 'btn_install' "Install or Update  script" pos:[25,92] width:152 height:24 align:#left
	button 'btn_delete' "Delete script" pos:[25,148] width:152 height:24 align:#left
	
	on Collect_Asset_install close do
	(
		--delete temp folder
		HiddenDOSCommand ("rmdir /S /Q \""+tempdirCA+"\"") exitCode:&exitcode
	)
	on btn_install pressed do
	(
		err = 0
		--delete old files
		deleteFile (usericonspath+"\\CollectAsset_16i.bmp")
		deleteFile (usericonspath+"\\CollectAsset_24i.bmp")
		--delete old version
		deleteFile (getdir(#userMacros)+"\\_ Scripts-Collect_asset_2.mcr")
		if (doesFileExist ((getdir #ui_ln)+"Icons\\CollectAsset_16i.bmp")) or (doesFileExist ((getdir #ui_ln)+"Icons\\CollectAsset_24i.bmp")) or (doesFileExist ((getdir #ui_ln)+"IconsDark\\CollectAsset_16i.bmp")) or (doesFileExist ((getdir #ui_ln)+"IconsDark\\CollectAsset_24i.bmp")) do
		(
			path_tmp = (getdir #ui_ln)
			if path_tmp[path_tmp.count] == "\\" do path_tmp = substring path_tmp 1 (path_tmp.count-1)
			DOSCommand ("powershell Start -File \"cmd '/c (\\\""+tempdirCA+"removeicons.bat\\\" \\\""+path_tmp+"\\\")'\" -Verb RunAs")
		)
		local listDir = getDirectories (tempdirCA+"\\Collect_asset\\*")
		append listDir (tempdirCA+"\\Collect_asset\\")
		--copy files section start
		for d in listDir do
		(
			find_s = "Collect_asset"
			subfolder = substring d ((findString d find_s)+find_s.count) d.count
			if not (doesFileExist (SETUP_PATH+subfolder) allowDirectory:true) do
					makeDir (SETUP_PATH+subfolder) all:true
			for f in getFiles (d + "*") do
			(
				copytofilename = ((SETUP_PATH+subfolder) + getFilenameFile f + getFilenameType f)
				if doesFileExist copytofilename do
					deleteFile copytofilename
				if not (copyFile f copytofilename) do err += 1
			)
		)
		copytofilename = ((getdir #userStartupScripts)+"\\collect_asset_startup.ms")
		if doesFileExist copytofilename do
			deleteFile copytofilename
		copyFile (tempdirCA+"collect_asset_startup.ms") copytofilename
		executeScriptFile copytofilename
		copytofilename = (getdir(#userMacros)+"\\Xiruim-Collect_asset_2.mcr")
		if doesFileExist copytofilename do
			deleteFile copytofilename
		copyFile (tempdirCA+"collect_asset_2.099e.ms") copytofilename
		executeScriptFile copytofilename
		--print ("Errors - " + err as string)
		--messageBox "Collect Asset is now installed!\n\nTo run it goto:\n   Customize -> Customize User Interface -> Toolbars\nCategory: \"Xiruim\" and drag \"Collect Asset\" to a toolbar.\n\nClick the toolbar icon to run it!" title:"Collect Asset Installed"
		createDialog installed_wnd modal:true
	)
	on btn_delete pressed do
	(
		if (doesFileExist ((getdir #ui_ln)+"Icons\\CollectAsset_16i.bmp")) or (doesFileExist ((getdir #ui_ln)+"Icons\\CollectAsset_24i.bmp")) or (doesFileExist ((getdir #ui_ln)+"IconsDark\\CollectAsset_16i.bmp")) or (doesFileExist ((getdir #ui_ln)+"IconsDark\\CollectAsset_24i.bmp")) do
		(
			path_tmp = (getdir #ui_ln)
			if path_tmp[path_tmp.count] == "\\" do path_tmp = substring path_tmp 1 (path_tmp.count-1)
			DOSCommand ("powershell Start -File \"cmd '/c (\\\""+tempdirCA+"removeicons.bat\\\" \\\""+path_tmp+"\\\")'\" -Verb RunAs")
		)
		deleteFile (getdir(#userMacros)+"\\_ Scripts-Collect_asset_2.mcr")
		deleteFile (getdir(#userMacros)+"\\Xiruim-Collect_asset_2.mcr")
		deleteFile ((getdir #userStartupScripts)+"\\collect_asset_startup.ms")
		deleteFile (usericonspath+"\\CollectAsset_16i.bmp")
		deleteFile (usericonspath+"\\CollectAsset_24i.bmp")
		HiddenDOSCommand ("rmdir /S /Q \""+SETUP_PATH+"\"") exitCode:&exitcode
		messageBox "Collect Asset Removed!" title:"Collect Asset Remove"
	)
)
CreateDialog Collect_Asset_install